org.mariadb.jdbc

## Class MySQLResultSet

- java.lang.Object
- - org.mariadb.jdbc.MySQLResultSet

All Implemented Interfaces:
  AutoCloseable, ResultSet, Wrapper

    public class MySQLResultSet
    extends Object
    implements ResultSet

### Field Summary

Fields
`static MySQLResultSet` `EMPTY`

### Fields inherited from interface java.sql.ResultSet

`CLOSE_CURSORS_AT_COMMIT, CONCUR_READ_ONLY, CONCUR_UPDATABLE, FETCH_FORWARD, FETCH_REVERSE, FETCH_UNKNOWN, HOLD_CURSORS_OVER_COMMIT, TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, TYPE_SCROLL_SENSITIVE`

### Constructor Summary

Constructors
`protected` `MySQLResultSet()`
`` `MySQLResultSet(QueryResult dqr, Statement statement, MySQLProtocol protocol, Calendar cal)`

### Method Summary

Methods
`boolean` `absolute(int row)` Moves the cursor to the given row number in this `ResultSet` object.
`void` `afterLast()` Moves the cursor to the end of this `ResultSet` object, just after the last row.
`void` `beforeFirst()` Moves the cursor to the front of this `ResultSet` object, just before the first row.
`void` `cancelRowUpdates()` Cancels the updates made to the current row in this `ResultSet` object.
`void` `clearWarnings()` Clears all warnings reported on this `ResultSet` object.
`void` `close()`
`void` `deleteRow()` Deletes the current row from this `ResultSet` object and from the underlying database.
`int` `findColumn(String columnLabel)` Maps the given `ResultSet` column label to its `ResultSet` column index.
`boolean` `first()` Moves the cursor to the first row in this `ResultSet` object.
`Array` `getArray(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Array` object in the Java programming language.
`Array` `getArray(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Array` object in the Java programming language.
`InputStream` `getAsciiStream(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of ASCII characters.
`InputStream` `getAsciiStream(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of ASCII characters.
`BigDecimal` `getBigDecimal(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` with full precision.
`BigDecimal` `getBigDecimal(int columnIndex, int scale)` Deprecated.
`BigDecimal` `getBigDecimal(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` with full precision.
`BigDecimal` `getBigDecimal(String columnLabel, int scale)` Deprecated.
`InputStream` `getBinaryStream(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of uninterpreted bytes.
`InputStream` `getBinaryStream(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of uninterpreted `byte`s.
`Blob` `getBlob(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Blob` object in the Java programming language.
`Blob` `getBlob(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Blob` object in the Java programming language.
`boolean` `getBoolean(int i)`
`boolean` `getBoolean(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `boolean` in the Java programming language.
`byte` `getByte(int i)`
`byte` `getByte(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` in the Java programming language.
`byte[]` `getBytes(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` array in the Java programming language.
`byte[]` `getBytes(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` array in the Java programming language.
`Reader` `getCharacterStream(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object.
`Reader` `getCharacterStream(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object.
`Clob` `getClob(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Clob` object in the Java programming language.
`Clob` `getClob(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Clob` object in the Java programming language.
`int` `getConcurrency()` Retrieves the concurrency mode of this `ResultSet` object.
`String` `getCursorName()` Retrieves the name of the SQL cursor used by this `ResultSet` object.
`Date` `getDate(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.
`Date` `getDate(int columnIndex, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.
`Date` `getDate(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.
`Date` `getDate(String columnLabel, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.
`double` `getDouble(int i)`
`double` `getDouble(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `double` in the Java programming language.
`int` `getFetchDirection()` Retrieves the fetch direction for this `ResultSet` object.
`int` `getFetchSize()` Retrieves the fetch size for this `ResultSet` object.
`float` `getFloat(int i)`
`float` `getFloat(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `float` in the Java programming language.
`int` `getHoldability()` Retrieves the holdability of this `ResultSet` object
`int` `getInt(int i)`
`int` `getInt(String s)`
`long` `getLong(int i)`
`long` `getLong(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `long` in the Java programming language.
`ResultSetMetaData` `getMetaData()` Retrieves the number, types and properties of this `ResultSet` object's columns.
`Reader` `getNCharacterStream(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object.
`Reader` `getNCharacterStream(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object.
`NClob` `getNClob(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `NClob` object in the Java programming language.
`NClob` `getNClob(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `NClob` object in the Java programming language.
`String` `getNString(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `String` in the Java programming language.
`String` `getNString(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `String` in the Java programming language.
`Object` `getObject(int columnIndex)` Gets the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.
`<T> T` `getObject(int arg0, Class<T> arg1)`
`Object` `getObject(int columnIndex, Map<String,Class<?>> map)` According to the JDBC4 spec, this is only required for UDT's, and since drizzle does not support UDTs, this method ignores the map parameter Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.
`Object` `getObject(String columnLabel)` Gets the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.
`<T> T` `getObject(String arg0, Class<T> arg1)`
`Object` `getObject(String columnLabel, Map<String,Class<?>> map)` According to the JDBC4 spec, this is only required for UDT's, and since drizzle does not support UDTs, this method ignores the map parameter Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.
`Ref` `getRef(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Ref` object in the Java programming language.
`Ref` `getRef(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Ref` object in the Java programming language.
`int` `getRow()` Retrieves the current row number.
`RowId` `getRowId(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.RowId` object in the Java programming language.
`RowId` `getRowId(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.RowId` object in the Java programming language.
`short` `getShort(int i)`
`short` `getShort(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `short` in the Java programming language.
`SQLXML` `getSQLXML(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` as a `java.sql.SQLXML` object in the Java programming language.
`SQLXML` `getSQLXML(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` as a `java.sql.SQLXML` object in the Java programming language.
`Statement` `getStatement()` Retrieves the `Statement` object that produced this `ResultSet` object.
`String` `getString(int i)`
`String` `getString(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `String` in the Java programming language.
`Time` `getTime(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.
`Time` `getTime(int columnIndex, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.
`Time` `getTime(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.
`Time` `getTime(String columnLabel, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.
`Timestamp` `getTimestamp(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language.
`Timestamp` `getTimestamp(int columnIndex, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language.
`Timestamp` `getTimestamp(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language.
`Timestamp` `getTimestamp(String columnLabel, Calendar cal)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language.
`int` `getType()` Retrieves the type of this `ResultSet` object.
`InputStream` `getUnicodeStream(int columnIndex)` Deprecated. use `getCharacterStream` in place of `getUnicodeStream`
`InputStream` `getUnicodeStream(String columnLabel)` Deprecated. use `getCharacterStream` instead
`URL` `getURL(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.net.URL` object in the Java programming language.
`URL` `getURL(String columnLabel)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.net.URL` object in the Java programming language.
`SQLWarning` `getWarnings()` Retrieves the first warning reported by calls on this `ResultSet` object.
`void` `insertRow()` Inserts the contents of the insert row into this `ResultSet` object and into the database.
`boolean` `isAfterLast()` Retrieves whether the cursor is after the last row in this `ResultSet` object.
`boolean` `isBeforeFirst()` Retrieves whether the cursor is before the first row in this `ResultSet` object.
`boolean` `isClosed()` Retrieves whether this `ResultSet` object has been closed.
`boolean` `isFirst()` Retrieves whether the cursor is on the first row of this `ResultSet` object.
`boolean` `isLast()` Retrieves whether the cursor is on the last row of this `ResultSet` object.
`boolean` `isWrapperFor(Class<?> iface)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`boolean` `last()` Moves the cursor to the last row in this `ResultSet` object.
`void` `moveToCurrentRow()` Moves the cursor to the remembered cursor position, usually the current row.
`void` `moveToInsertRow()` Moves the cursor to the insert row.
`boolean` `next()`
`boolean` `previous()` Moves the cursor to the previous row in this `ResultSet` object.
`void` `refreshRow()` Refreshes the current row with its most recent value in the database.
`boolean` `relative(int rows)` Moves the cursor a relative number of rows, either positive or negative.
`boolean` `rowDeleted()` Retrieves whether a row has been deleted.
`boolean` `rowInserted()` Retrieves whether the current row has had an insertion.
`boolean` `rowUpdated()` Retrieves whether the current row has been updated.
`void` `setFetchDirection(int direction)` Gives a hint as to the direction in which the rows in this `ResultSet` object will be processed.
`void` `setFetchSize(int rows)` Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for this `ResultSet` object.
`<T> T` `unwrap(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.
`void` `updateArray(int columnIndex, Array x)` Updates the designated column with a `java.sql.Array` value.
`void` `updateArray(String columnLabel, Array x)` Updates the designated column with a `java.sql.Array` value.
`void` `updateAsciiStream(int columnIndex, InputStream x)` Updates the designated column with an ascii stream value.
`void` `updateAsciiStream(int columnIndex, InputStream x, int length)` Updates the designated column with an ascii stream value, which will have the specified number of bytes.
`void` `updateAsciiStream(int columnIndex, InputStream x, long length)` Updates the designated column with an ascii stream value, which will have the specified number of bytes.
`void` `updateAsciiStream(String columnLabel, InputStream x)` Updates the designated column with an ascii stream value.
`void` `updateAsciiStream(String columnLabel, InputStream x, int length)` Updates the designated column with an ascii stream value, which will have the specified number of bytes.
`void` `updateAsciiStream(String columnLabel, InputStream x, long length)` Updates the designated column with an ascii stream value, which will have the specified number of bytes.
`void` `updateBigDecimal(int columnIndex, BigDecimal x)` Updates the designated column with a `java.math.BigDecimal` value.
`void` `updateBigDecimal(String columnLabel, BigDecimal x)` Updates the designated column with a `java.sql.BigDecimal` value.
`void` `updateBinaryStream(int columnIndex, InputStream x)` Updates the designated column with a binary stream value.
`void` `updateBinaryStream(int columnIndex, InputStream x, int length)` Updates the designated column with a binary stream value, which will have the specified number of bytes.
`void` `updateBinaryStream(int columnIndex, InputStream x, long length)` Updates the designated column with a binary stream value, which will have the specified number of bytes.
`void` `updateBinaryStream(String columnLabel, InputStream x)` Updates the designated column with a binary stream value.
`void` `updateBinaryStream(String columnLabel, InputStream x, int length)` Updates the designated column with a binary stream value, which will have the specified number of bytes.
`void` `updateBinaryStream(String columnLabel, InputStream x, long length)` Updates the designated column with a binary stream value, which will have the specified number of bytes.
`void` `updateBlob(int columnIndex, Blob x)` Updates the designated column with a `java.sql.Blob` value.
`void` `updateBlob(int columnIndex, InputStream inputStream)` Updates the designated column using the given input stream.
`void` `updateBlob(int columnIndex, InputStream inputStream, long length)` Updates the designated column using the given input stream, which will have the specified number of bytes.
`void` `updateBlob(String columnLabel, Blob x)` Updates the designated column with a `java.sql.Blob` value.
`void` `updateBlob(String columnLabel, InputStream inputStream)` Updates the designated column using the given input stream.
`void` `updateBlob(String columnLabel, InputStream inputStream, long length)` Updates the designated column using the given input stream, which will have the specified number of bytes.
`void` `updateBoolean(int columnIndex, boolean x)` Updates the designated column with a `boolean` value.
`void` `updateBoolean(String columnLabel, boolean x)` Updates the designated column with a `boolean` value.
`void` `updateByte(int columnIndex, byte x)` Updates the designated column with a `byte` value.
`void` `updateByte(String columnLabel, byte x)` Updates the designated column with a `byte` value.
`void` `updateBytes(int columnIndex, byte[] x)` Updates the designated column with a `byte` array value.
`void` `updateBytes(String columnLabel, byte[] x)` Updates the designated column with a byte array value.
`void` `updateCharacterStream(int columnIndex, Reader x)` Updates the designated column with a character stream value.
`void` `updateCharacterStream(int columnIndex, Reader x, int length)` Updates the designated column with a character stream value, which will have the specified number of bytes.
`void` `updateCharacterStream(int columnIndex, Reader x, long length)` Updates the designated column with a character stream value, which will have the specified number of bytes.
`void` `updateCharacterStream(String columnLabel, Reader reader)` Updates the designated column with a character stream value.
`void` `updateCharacterStream(String columnLabel, Reader reader, int length)` Updates the designated column with a character stream value, which will have the specified number of bytes.
`void` `updateCharacterStream(String columnLabel, Reader reader, long length)` Updates the designated column with a character stream value, which will have the specified number of bytes.
`void` `updateClob(int columnIndex, Clob x)` Updates the designated column with a `java.sql.Clob` value.
`void` `updateClob(int columnIndex, Reader reader)` Updates the designated column using the given `Reader` object.
`void` `updateClob(int columnIndex, Reader reader, long length)` Updates the designated column using the given `Reader` object, which is the given number of characters long.
`void` `updateClob(String columnLabel, Clob x)` Updates the designated column with a `java.sql.Clob` value.
`void` `updateClob(String columnLabel, Reader reader)` Updates the designated column using the given `Reader` object.
`void` `updateClob(String columnLabel, Reader reader, long length)` Updates the designated column using the given `Reader` object, which is the given number of characters long.
`void` `updateDate(int columnIndex, Date x)` Updates the designated column with a `java.sql.Date` value.
`void` `updateDate(String columnLabel, Date x)` Updates the designated column with a `java.sql.Date` value.
`void` `updateDouble(int columnIndex, double x)` Updates the designated column with a `double` value.
`void` `updateDouble(String columnLabel, double x)` Updates the designated column with a `double` value.
`void` `updateFloat(int columnIndex, float x)` Updates the designated column with a `float` value.
`void` `updateFloat(String columnLabel, float x)` Updates the designated column with a `float` value.
`void` `updateInt(int columnIndex, int x)` Updates the designated column with an `int` value.
`void` `updateInt(String columnLabel, int x)` Updates the designated column with an `int` value.
`void` `updateLong(int columnIndex, long x)` Updates the designated column with a `long` value.
`void` `updateLong(String columnLabel, long x)` Updates the designated column with a `long` value.
`void` `updateNCharacterStream(int columnIndex, Reader x)` Updates the designated column with a character stream value.
`void` `updateNCharacterStream(int columnIndex, Reader x, long length)` Updates the designated column with a character stream value, which will have the specified number of bytes.
`void` `updateNCharacterStream(String columnLabel, Reader reader)` Updates the designated column with a character stream value.
`void` `updateNCharacterStream(String columnLabel, Reader reader, long length)` Updates the designated column with a character stream value, which will have the specified number of bytes.
`void` `updateNClob(int columnIndex, NClob nClob)` Updates the designated column with a `java.sql.NClob` value.
`void` `updateNClob(int columnIndex, Reader reader)` Updates the designated column using the given `Reader` The data will be read from the stream as needed until end-of-stream is reached.
`void` `updateNClob(int columnIndex, Reader reader, long length)` Updates the designated column using the given `Reader` object, which is the given number of characters long.
`void` `updateNClob(String columnLabel, NClob nClob)` Updates the designated column with a `java.sql.NClob` value.
`void` `updateNClob(String columnLabel, Reader reader)` Updates the designated column using the given `Reader` object.
`void` `updateNClob(String columnLabel, Reader reader, long length)` Updates the designated column using the given `Reader` object, which is the given number of characters long.
`void` `updateNString(int columnIndex, String nString)` Updates the designated column with a `String` value.
`void` `updateNString(String columnLabel, String nString)` Updates the designated column with a `String` value.
`void` `updateNull(int columnIndex)` Updates the designated column with a `null` value.
`void` `updateNull(String columnLabel)` Updates the designated column with a `null` value.
`void` `updateObject(int columnIndex, Object x)` Updates the designated column with an `Object` value.
`void` `updateObject(int columnIndex, Object x, int scaleOrLength)` Updates the designated column with an `Object` value.
`void` `updateObject(String columnLabel, Object x)` Updates the designated column with an `Object` value.
`void` `updateObject(String columnLabel, Object x, int scaleOrLength)` Updates the designated column with an `Object` value.
`void` `updateRef(int columnIndex, Ref x)` Updates the designated column with a `java.sql.Ref` value.
`void` `updateRef(String columnLabel, Ref x)` Updates the designated column with a `java.sql.Ref` value.
`void` `updateRow()` Updates the underlying database with the new contents of the current row of this `ResultSet` object.
`void` `updateRowId(int columnIndex, RowId x)` Updates the designated column with a `RowId` value.
`void` `updateRowId(String columnLabel, RowId x)` Updates the designated column with a `RowId` value.
`void` `updateShort(int columnIndex, short x)` Updates the designated column with a `short` value.
`void` `updateShort(String columnLabel, short x)` Updates the designated column with a `short` value.
`void` `updateSQLXML(int columnIndex, SQLXML xmlObject)` Updates the designated column with a `java.sql.SQLXML` value.
`void` `updateSQLXML(String columnLabel, SQLXML xmlObject)` Updates the designated column with a `java.sql.SQLXML` value.
`void` `updateString(int columnIndex, String x)` Updates the designated column with a `String` value.
`void` `updateString(String columnLabel, String x)` Updates the designated column with a `String` value.
`void` `updateTime(int columnIndex, Time x)` Updates the designated column with a `java.sql.Time` value.
`void` `updateTime(String columnLabel, Time x)` Updates the designated column with a `java.sql.Time` value.
`void` `updateTimestamp(int columnIndex, Timestamp x)` Updates the designated column with a `java.sql.Timestamp` value.
`void` `updateTimestamp(String columnLabel, Timestamp x)` Updates the designated column with a `java.sql.Timestamp` value.
`boolean` `wasNull()` Reports whether the last column read had a value of SQL `NULL`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### EMPTY

    public static final MySQLResultSet EMPTY

### Constructor Detail

#### MySQLResultSet

    protected MySQLResultSet()

#### MySQLResultSet

    public MySQLResultSet(QueryResult dqr,
                  Statement statement,
                  MySQLProtocol protocol,
                  Calendar cal)

### Method Detail

#### next

    public boolean next()
                 throws SQLException

Specified by:
  `next` in interface `ResultSet`
Throws:
  `SQLException`

#### close

    public void close()
               throws SQLException

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `ResultSet`
Throws:
  `SQLException`

#### wasNull

    public boolean wasNull()
                    throws SQLException

Reports whether the last column read had a value of SQL `NULL`. Note that you must first call one of the getter methods on a column to try to read its value and then call the method `wasNull` to see if the value read was SQL `NULL`.

Specified by:
  `wasNull` in interface `ResultSet`
Returns:
  `true` if the last column value read was SQL `NULL` and `false` otherwise
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set

#### getString

    public String getString(int i)
                     throws SQLException

Specified by:
  `getString` in interface `ResultSet`
Throws:
  `SQLException`

#### getInt

    public int getInt(int i)
               throws SQLException

Specified by:
  `getInt` in interface `ResultSet`
Throws:
  `SQLException`

#### getInt

    public int getInt(String s)
               throws SQLException

Specified by:
  `getInt` in interface `ResultSet`
Throws:
  `SQLException`

#### getLong

    public long getLong(String columnLabel)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `long` in the Java programming language.

Specified by:
  `getLong` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `0`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getFloat

    public float getFloat(String columnLabel)
                   throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `float` in the Java programming language.

Specified by:
  `getFloat` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `0`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getDouble

    public double getDouble(String columnLabel)
                     throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `double` in the Java programming language.

Specified by:
  `getDouble` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `0`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getBigDecimal

    public BigDecimal getBigDecimal(String columnLabel,
                           int scale)
                             throws SQLException

Deprecated.
Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` in the Java programming language.

Specified by:
  `getBigDecimal` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `scale` - the number of digits to the right of the decimal point
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### getBytes

    public byte[] getBytes(String columnLabel)
                    throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` array in the Java programming language. The bytes represent the raw values returned by the driver.

Specified by:
  `getBytes` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getDate

    public Date getDate(String columnLabel)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.

Specified by:
  `getDate` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getTime

    public Time getTime(String columnLabel)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.

Specified by:
  `getTime` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getTimestamp

    public Timestamp getTimestamp(String columnLabel)
                           throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language.

Specified by:
  `getTimestamp` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getAsciiStream

    public InputStream getAsciiStream(String columnLabel)
                               throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of ASCII characters. The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large `LONGVARCHAR` values. The JDBC driver will do any necessary conversion from the database format into ASCII.

Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `available` is called whether there is data available or not.

Specified by:
  `getAsciiStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a Java input stream that delivers the database column value as a stream of one-byte ASCII characters. If the value is SQL `NULL`, the value returned is `null`.
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getUnicodeStream

    public InputStream getUnicodeStream(String columnLabel)
                                 throws SQLException

Deprecated. use `getCharacterStream` instead
Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of two-byte Unicode characters. The first byte is the high byte; the second byte is the low byte.

The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large `LONGVARCHAR` values. The JDBC technology-enabled driver will do any necessary conversion from the database format into Unicode.

Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `InputStream.available` is called, whether there is data available or not.

Specified by:
  `getUnicodeStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a Java input stream that delivers the database column value as a stream of two-byte Unicode characters. If the value is SQL `NULL`, the value returned is `null`.
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### getBinaryStream

    public InputStream getBinaryStream(String columnLabel)
                                throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of uninterpreted `byte`s. The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large `LONGVARBINARY` values.

Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `available` is called whether there is data available or not.

Specified by:
  `getBinaryStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a Java input stream that delivers the database column value as a stream of uninterpreted bytes; if the value is SQL `NULL`, the result is `null`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

Retrieves the first warning reported by calls on this `ResultSet` object. Subsequent warnings on this `ResultSet` object will be chained to the `SQLWarning` object that this method returns.

The warning chain is automatically cleared each time a new row is read. This method may not be called on a `ResultSet` object that has been closed; doing so will cause an `SQLException` to be thrown.

Note: This warning chain only covers warnings caused by `ResultSet` methods. Any warning caused by `Statement` methods (such as reading OUT parameters) will be chained on the `Statement` object.

Specified by:
  `getWarnings` in interface `ResultSet`
Returns:
  the first `SQLWarning` object reported or `null` if there are none
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set

#### clearWarnings

    public void clearWarnings()
                       throws SQLException

Clears all warnings reported on this `ResultSet` object. After this method is called, the method `getWarnings` returns `null` until a new warning is reported for this `ResultSet` object.

Specified by:
  `clearWarnings` in interface `ResultSet`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set

#### getCursorName

    public String getCursorName()
                         throws SQLException

Retrieves the name of the SQL cursor used by this `ResultSet` object.

In SQL, a result table is retrieved through a cursor that is named. The current row of a result set can be updated or deleted using a positioned update/delete statement that references the cursor name. To insure that the cursor has the proper isolation level to support update, the cursor's `SELECT` statement should be of the form `SELECT FOR UPDATE`. If `FOR UPDATE` is omitted, the positioned updates may fail.

The JDBC API supports this SQL feature by providing the name of the SQL cursor used by a `ResultSet` object. The current row of a `ResultSet` object is also the current row of this SQL cursor.

Specified by:
  `getCursorName` in interface `ResultSet`
Returns:
  the SQL name for this `ResultSet` object's cursor
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### getMetaData

    public ResultSetMetaData getMetaData()
                                  throws SQLException

Retrieves the number, types and properties of this `ResultSet` object's columns.

Specified by:
  `getMetaData` in interface `ResultSet`
Returns:
  the description of this `ResultSet` object's columns
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set

#### getObject

    public Object getObject(int columnIndex)
                     throws SQLException

Gets the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.

This method will return the value of the given column as a Java object. The type of the Java object will be the default Java object type corresponding to the column's SQL type, following the mapping for built-in types specified in the JDBC specification. If the value is an SQL `NULL`, the driver returns a Java `null`.

This method may also be used to read database-specific abstract data types.

In the JDBC 2.0 API, the behavior of method `getObject` is extended to materialize data of SQL user-defined types.

If `Connection.getTypeMap` does not throw a `SQLFeatureNotSupportedException`, then when a column contains a structured or distinct value, the behavior of this method is as if it were a call to: `getObject(columnIndex, this.getStatement().getConnection().getTypeMap())`.

If `Connection.getTypeMap` does throw a `SQLFeatureNotSupportedException`, then structured values are not supported, and distinct values are mapped to the default Java class as determined by the underlying SQL type of the DISTINCT type.

Specified by:
  `getObject` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a `java.lang.Object` holding the column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set

#### getObject

    public Object getObject(String columnLabel)
                     throws SQLException

Gets the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language.

This method will return the value of the given column as a Java object. The type of the Java object will be the default Java object type corresponding to the column's SQL type, following the mapping for built-in types specified in the JDBC specification. If the value is an SQL `NULL`, the driver returns a Java `null`.

This method may also be used to read database-specific abstract data types.

In the JDBC 2.0 API, the behavior of the method `getObject` is extended to materialize data of SQL user-defined types. When a column contains a structured or distinct value, the behavior of this method is as if it were a call to: `getObject(columnIndex, this.getStatement().getConnection().getTypeMap())`.

Specified by:
  `getObject` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a `java.lang.Object` holding the column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### findColumn

    public int findColumn(String columnLabel)
                   throws SQLException

Maps the given `ResultSet` column label to its `ResultSet` column index.

Specified by:
  `findColumn` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column index of the given column name
Throws:
  `SQLException` - if the `ResultSet` object does not contain a column labeled `columnLabel`, a database access error occurs or this method is called on a closed result set

#### getCharacterStream

    public Reader getCharacterStream(int columnIndex)
                              throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object.

Specified by:
  `getCharacterStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a `java.io.Reader` object that contains the column value; if the value is SQL `NULL`, the value returned is `null` in the Java programming language.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getCharacterStream

    public Reader getCharacterStream(String columnLabel)
                              throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object.

Specified by:
  `getCharacterStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a `java.io.Reader` object that contains the column value; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getBigDecimal

    public BigDecimal getBigDecimal(int columnIndex)
                             throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` with full precision.

Specified by:
  `getBigDecimal` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  the column value (full precision); if the value is SQL `NULL`, the value returned is `null` in the Java programming language.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getBigDecimal

    public BigDecimal getBigDecimal(String columnLabel)
                             throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.math.BigDecimal` with full precision.

Specified by:
  `getBigDecimal` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value (full precision); if the value is SQL `NULL`, the value returned is `null` in the Java programming language.
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### isBeforeFirst

    public boolean isBeforeFirst()
                          throws SQLException

Retrieves whether the cursor is before the first row in this `ResultSet` object.

Note:Support for the `isBeforeFirst` method is optional for `ResultSet`s with a result set type of `TYPE_FORWARD_ONLY`

Specified by:
  `isBeforeFirst` in interface `ResultSet`
Returns:
  `true` if the cursor is before the first row; `false` if the cursor is at any other position or the result set contains no rows
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### isAfterLast

    public boolean isAfterLast()
                        throws SQLException

Retrieves whether the cursor is after the last row in this `ResultSet` object.

Note:Support for the `isAfterLast` method is optional for `ResultSet`s with a result set type of `TYPE_FORWARD_ONLY`

Specified by:
  `isAfterLast` in interface `ResultSet`
Returns:
  `true` if the cursor is after the last row; `false` if the cursor is at any other position or the result set contains no rows
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### isFirst

    public boolean isFirst()
                    throws SQLException

Retrieves whether the cursor is on the first row of this `ResultSet` object.

Note:Support for the `isFirst` method is optional for `ResultSet`s with a result set type of `TYPE_FORWARD_ONLY`

Specified by:
  `isFirst` in interface `ResultSet`
Returns:
  `true` if the cursor is on the first row; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### isLast

    public boolean isLast()
                   throws SQLException

Retrieves whether the cursor is on the last row of this `ResultSet` object. Note: Calling the method `isLast` may be expensive because the JDBC driver might need to fetch ahead one row in order to determine whether the current row is the last row in the result set.

Note: Support for the `isLast` method is optional for `ResultSet`s with a result set type of `TYPE_FORWARD_ONLY`

Specified by:
  `isLast` in interface `ResultSet`
Returns:
  `true` if the cursor is on the last row; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### beforeFirst

    public void beforeFirst()
                     throws SQLException

Moves the cursor to the front of this `ResultSet` object, just before the first row. This method has no effect if the result set contains no rows.

Specified by:
  `beforeFirst` in interface `ResultSet`
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the result set type is `TYPE_FORWARD_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### afterLast

    public void afterLast()
                   throws SQLException

Moves the cursor to the end of this `ResultSet` object, just after the last row. This method has no effect if the result set contains no rows.

Specified by:
  `afterLast` in interface `ResultSet`
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the result set type is `TYPE_FORWARD_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### first

    public boolean first()
                  throws SQLException

Moves the cursor to the first row in this `ResultSet` object.

Specified by:
  `first` in interface `ResultSet`
Returns:
  `true` if the cursor is on a valid row; `false` if there are no rows in the result set
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the result set type is `TYPE_FORWARD_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### last

    public boolean last()
                 throws SQLException

Moves the cursor to the last row in this `ResultSet` object.

Specified by:
  `last` in interface `ResultSet`
Returns:
  `true` if the cursor is on a valid row; `false` if there are no rows in the result set
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the result set type is `TYPE_FORWARD_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getRow

    public int getRow()
               throws SQLException

Retrieves the current row number. The first row is number 1, the second number 2, and so on.

Note:Support for the `getRow` method is optional for `ResultSet`s with a result set type of `TYPE_FORWARD_ONLY`

Specified by:
  `getRow` in interface `ResultSet`
Returns:
  the current row number; `0` if there is no current row
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### absolute

    public boolean absolute(int row)
                     throws SQLException

Moves the cursor to the given row number in this `ResultSet` object.

If the row number is positive, the cursor moves to the given row number with respect to the beginning of the result set. The first row is row 1, the second is row 2, and so on.

If the given row number is negative, the cursor moves to an absolute row position with respect to the end of the result set. For example, calling the method `absolute(-1)` positions the cursor on the last row; calling the method `absolute(-2)` moves the cursor to the next-to-last row, and so on.

An attempt to position the cursor beyond the first/last row in the result set leaves the cursor before the first row or after the last row.

Note: Calling `absolute(1)` is the same as calling `first()`. Calling `absolute(-1)` is the same as calling `last()`.

Specified by:
  `absolute` in interface `ResultSet`
Parameters:
  `row` - the number of the row to which the cursor should move. A positive number indicates the row number counting from the beginning of the result set; a negative number indicates the row number counting from the end of the result set
Returns:
  `true` if the cursor is moved to a position in this `ResultSet` object; `false` if the cursor is before the first row or after the last row
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the result set type is `TYPE_FORWARD_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### relative

    public boolean relative(int rows)
                     throws SQLException

Moves the cursor a relative number of rows, either positive or negative. Attempting to move beyond the first/last row in the result set positions the cursor before/after the the first/last row. Calling `relative(0)` is valid, but does not change the cursor position.

Note: Calling the method `relative(1)` is identical to calling the method `next()` and calling the method `relative(-1)` is identical to calling the method `previous()`.

Specified by:
  `relative` in interface `ResultSet`
Parameters:
  `rows` - an `int` specifying the number of rows to move from the current row; a positive number moves the cursor forward; a negative number moves the cursor backward
Returns:
  `true` if the cursor is on a row; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the result set type is `TYPE_FORWARD_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### previous

    public boolean previous()
                     throws SQLException

Moves the cursor to the previous row in this `ResultSet` object.

When a call to the `previous` method returns `false`, the cursor is positioned before the first row. Any invocation of a `ResultSet` method which requires a current row will result in a `SQLException` being thrown.

If an input stream is open for the current row, a call to the method `previous` will implicitly close it. A `ResultSet` object's warning change is cleared when a new row is read.

Specified by:
  `previous` in interface `ResultSet`
Returns:
  `true` if the cursor is now positioned on a valid row; `false` if the cursor is positioned before the first row
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the result set type is `TYPE_FORWARD_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### setFetchDirection

    public void setFetchDirection(int direction)
                           throws SQLException

Gives a hint as to the direction in which the rows in this `ResultSet` object will be processed. The initial value is determined by the `Statement` object that produced this `ResultSet` object. The fetch direction may be changed at any time.

Specified by:
  `setFetchDirection` in interface `ResultSet`
Parameters:
  `direction` - an `int` specifying the suggested fetch direction; one of `ResultSet.FETCH_FORWARD`, `ResultSet.FETCH_REVERSE`, or `ResultSet.FETCH_UNKNOWN`
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the result set type is `TYPE_FORWARD_ONLY` and the fetch direction is not `FETCH_FORWARD`
Since:
  1.2
See Also:
  `Statement.setFetchDirection(int)`, `getFetchDirection()`

#### getFetchDirection

    public int getFetchDirection()
                          throws SQLException

Retrieves the fetch direction for this `ResultSet` object.

Specified by:
  `getFetchDirection` in interface `ResultSet`
Returns:
  the current fetch direction for this `ResultSet` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
Since:
  1.2
See Also:
  `setFetchDirection(int)`

#### setFetchSize

    public void setFetchSize(int rows)
                      throws SQLException

Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for this `ResultSet` object. If the fetch size specified is zero, the JDBC driver ignores the value and is free to make its own best guess as to what the fetch size should be. The default value is set by the `Statement` object that created the result set. The fetch size may be changed at any time.

Specified by:
  `setFetchSize` in interface `ResultSet`
Parameters:
  `rows` - the number of rows to fetch
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the condition `rows >= 0` is not satisfied
Since:
  1.2
See Also:
  `getFetchSize()`

#### getFetchSize

    public int getFetchSize()
                     throws SQLException

Retrieves the fetch size for this `ResultSet` object.

Specified by:
  `getFetchSize` in interface `ResultSet`
Returns:
  the current fetch size for this `ResultSet` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
Since:
  1.2
See Also:
  `setFetchSize(int)`

#### getType

    public int getType()
                throws SQLException

Retrieves the type of this `ResultSet` object. The type is determined by the `Statement` object that created the result set.

Specified by:
  `getType` in interface `ResultSet`
Returns:
  `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getConcurrency

    public int getConcurrency()
                       throws SQLException

Retrieves the concurrency mode of this `ResultSet` object. The concurrency used is determined by the `Statement` object that created the result set.

Specified by:
  `getConcurrency` in interface `ResultSet`
Returns:
  the concurrency type, either `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### rowUpdated

    public boolean rowUpdated()
                       throws SQLException

Retrieves whether the current row has been updated. The value returned depends on whether or not the result set can detect updates.

Note: Support for the `rowUpdated` method is optional with a result set concurrency of `CONCUR_READ_ONLY`

Specified by:
  `rowUpdated` in interface `ResultSet`
Returns:
  `true` if the current row is detected to have been visibly updated by the owner or another; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2
See Also:
  `DatabaseMetaData.updatesAreDetected(int)`

#### rowInserted

    public boolean rowInserted()
                        throws SQLException

Retrieves whether the current row has had an insertion. The value returned depends on whether or not this `ResultSet` object can detect visible inserts.

Note: Support for the `rowInserted` method is optional with a result set concurrency of `CONCUR_READ_ONLY`

Specified by:
  `rowInserted` in interface `ResultSet`
Returns:
  `true` if the current row is detected to have been inserted; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2
See Also:
  `DatabaseMetaData.insertsAreDetected(int)`

#### rowDeleted

    public boolean rowDeleted()
                       throws SQLException

Retrieves whether a row has been deleted. A deleted row may leave a visible "hole" in a result set. This method can be used to detect holes in a result set. The value returned depends on whether or not this `ResultSet` object can detect deletions.

Note: Support for the `rowDeleted` method is optional with a result set concurrency of `CONCUR_READ_ONLY`

Specified by:
  `rowDeleted` in interface `ResultSet`
Returns:
  `true` if the current row is detected to have been deleted by the owner or another; `false` otherwise
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2
See Also:
  `DatabaseMetaData.deletesAreDetected(int)`

#### updateNull

    public void updateNull(int columnIndex)
                    throws SQLException

Updates the designated column with a `null` value.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateNull` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateBoolean

    public void updateBoolean(int columnIndex,
                     boolean x)
                       throws SQLException

Updates the designated column with a `boolean` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBoolean` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateByte

    public void updateByte(int columnIndex,
                  byte x)
                    throws SQLException

Updates the designated column with a `byte` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateByte` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateShort

    public void updateShort(int columnIndex,
                   short x)
                     throws SQLException

Updates the designated column with a `short` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateShort` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateInt

    public void updateInt(int columnIndex,
                 int x)
                   throws SQLException

Updates the designated column with an `int` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateInt` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateLong

    public void updateLong(int columnIndex,
                  long x)
                    throws SQLException

Updates the designated column with a `long` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateLong` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateFloat

    public void updateFloat(int columnIndex,
                   float x)
                     throws SQLException

Updates the designated column with a `float` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateFloat` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateDouble

    public void updateDouble(int columnIndex,
                    double x)
                      throws SQLException

Updates the designated column with a `double` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateDouble` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateBigDecimal

    public void updateBigDecimal(int columnIndex,
                        BigDecimal x)
                          throws SQLException

Updates the designated column with a `java.math.BigDecimal` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBigDecimal` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateString

    public void updateString(int columnIndex,
                    String x)
                      throws SQLException

Updates the designated column with a `String` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateString` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateBytes

    public void updateBytes(int columnIndex,
                   byte[] x)
                     throws SQLException

Updates the designated column with a `byte` array value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBytes` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateDate

    public void updateDate(int columnIndex,
                  Date x)
                    throws SQLException

Updates the designated column with a `java.sql.Date` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateDate` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateTime

    public void updateTime(int columnIndex,
                  Time x)
                    throws SQLException

Updates the designated column with a `java.sql.Time` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateTime` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateTimestamp

    public void updateTimestamp(int columnIndex,
                       Timestamp x)
                         throws SQLException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateTimestamp` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateAsciiStream

    public void updateAsciiStream(int columnIndex,
                         InputStream x,
                         int length)
                           throws SQLException

Updates the designated column with an ascii stream value, which will have the specified number of bytes. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateBinaryStream

    public void updateBinaryStream(int columnIndex,
                          InputStream x,
                          int length)
                            throws SQLException

Updates the designated column with a binary stream value, which will have the specified number of bytes. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateCharacterStream

    public void updateCharacterStream(int columnIndex,
                             Reader x,
                             int length)
                               throws SQLException

Updates the designated column with a character stream value, which will have the specified number of bytes. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateObject

    public void updateObject(int columnIndex,
                    Object x,
                    int scaleOrLength)
                      throws SQLException

Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

If the second argument is an `InputStream` then the stream must contain the number of bytes specified by scaleOrLength. If the second argument is a `Reader` then the reader must contain the number of characters specified by scaleOrLength. If these conditions are not true the driver will generate a `SQLException` when the statement is executed.

Specified by:
  `updateObject` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `scaleOrLength` - for an object of `java.math.BigDecimal` , this is the number of digits after the decimal point. For Java Object types `InputStream` and `Reader`, this is the length of the data in the stream or reader. For all other types, this value will be ignored.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateObject

    public void updateObject(int columnIndex,
                    Object x)
                      throws SQLException

Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateObject` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateNull

    public void updateNull(String columnLabel)
                    throws SQLException

Updates the designated column with a `null` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateNull` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateBoolean

    public void updateBoolean(String columnLabel,
                     boolean x)
                       throws SQLException

Updates the designated column with a `boolean` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBoolean` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateByte

    public void updateByte(String columnLabel,
                  byte x)
                    throws SQLException

Updates the designated column with a `byte` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateByte` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateShort

    public void updateShort(String columnLabel,
                   short x)
                     throws SQLException

Updates the designated column with a `short` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateShort` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateInt

    public void updateInt(String columnLabel,
                 int x)
                   throws SQLException

Updates the designated column with an `int` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateInt` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateLong

    public void updateLong(String columnLabel,
                  long x)
                    throws SQLException

Updates the designated column with a `long` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateLong` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateFloat

    public void updateFloat(String columnLabel,
                   float x)
                     throws SQLException

Updates the designated column with a `float` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateFloat` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateDouble

    public void updateDouble(String columnLabel,
                    double x)
                      throws SQLException

Updates the designated column with a `double` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateDouble` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateBigDecimal

    public void updateBigDecimal(String columnLabel,
                        BigDecimal x)
                          throws SQLException

Updates the designated column with a `java.sql.BigDecimal` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBigDecimal` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateString

    public void updateString(String columnLabel,
                    String x)
                      throws SQLException

Updates the designated column with a `String` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateString` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateBytes

    public void updateBytes(String columnLabel,
                   byte[] x)
                     throws SQLException

Updates the designated column with a byte array value.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBytes` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateDate

    public void updateDate(String columnLabel,
                  Date x)
                    throws SQLException

Updates the designated column with a `java.sql.Date` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateDate` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateTime

    public void updateTime(String columnLabel,
                  Time x)
                    throws SQLException

Updates the designated column with a `java.sql.Time` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateTime` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateTimestamp

    public void updateTimestamp(String columnLabel,
                       Timestamp x)
                         throws SQLException

Updates the designated column with a `java.sql.Timestamp` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateTimestamp` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateAsciiStream

    public void updateAsciiStream(String columnLabel,
                         InputStream x,
                         int length)
                           throws SQLException

Updates the designated column with an ascii stream value, which will have the specified number of bytes. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateBinaryStream

    public void updateBinaryStream(String columnLabel,
                          InputStream x,
                          int length)
                            throws SQLException

Updates the designated column with a binary stream value, which will have the specified number of bytes. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateCharacterStream

    public void updateCharacterStream(String columnLabel,
                             Reader reader,
                             int length)
                               throws SQLException

Updates the designated column with a character stream value, which will have the specified number of bytes. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - the `java.io.Reader` object containing the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateObject

    public void updateObject(String columnLabel,
                    Object x,
                    int scaleOrLength)
                      throws SQLException

Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

If the second argument is an `InputStream` then the stream must contain the number of bytes specified by scaleOrLength. If the second argument is a `Reader` then the reader must contain the number of characters specified by scaleOrLength. If these conditions are not true the driver will generate a `SQLException` when the statement is executed.

Specified by:
  `updateObject` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
  `scaleOrLength` - for an object of `java.math.BigDecimal` , this is the number of digits after the decimal point. For Java Object types `InputStream` and `Reader`, this is the length of the data in the stream or reader. For all other types, this value will be ignored.
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateObject

    public void updateObject(String columnLabel,
                    Object x)
                      throws SQLException

Updates the designated column with an `Object` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateObject` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### insertRow

    public void insertRow()
                   throws SQLException

Inserts the contents of the insert row into this `ResultSet` object and into the database. The cursor must be on the insert row when this method is called.

Specified by:
  `insertRow` in interface `ResultSet`
Throws:
  `SQLException` - if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY`, this method is called on a closed result set, if this method is called when the cursor is not on the insert row, or if not all of non-nullable columns in the insert row have been given a non-null value
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### updateRow

    public void updateRow()
                   throws SQLException

Updates the underlying database with the new contents of the current row of this `ResultSet` object. This method cannot be called when the cursor is on the insert row.

Specified by:
  `updateRow` in interface `ResultSet`
Throws:
  `SQLException` - if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY`; this method is called on a closed result set or if this method is called when the cursor is on the insert row
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### deleteRow

    public void deleteRow()
                   throws SQLException

Deletes the current row from this `ResultSet` object and from the underlying database. This method cannot be called when the cursor is on the insert row.

Specified by:
  `deleteRow` in interface `ResultSet`
Throws:
  `SQLException` - if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY`; this method is called on a closed result set or if this method is called when the cursor is on the insert row
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### refreshRow

    public void refreshRow()
                    throws SQLException

Refreshes the current row with its most recent value in the database. This method cannot be called when the cursor is on the insert row.

The `refreshRow` method provides a way for an application to explicitly tell the JDBC driver to refetch a row(s) from the database. An application may want to call `refreshRow` when caching or prefetching is being done by the JDBC driver to fetch the latest value of a row from the database. The JDBC driver may actually refresh multiple rows at once if the fetch size is greater than one.

All values are refetched subject to the transaction isolation level and cursor sensitivity. If `refreshRow` is called after calling an updater method, but before calling the method `updateRow`, then the updates made to the row are lost. Calling the method `refreshRow` frequently will likely slow performance.

Specified by:
  `refreshRow` in interface `ResultSet`
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set; the result set type is `TYPE_FORWARD_ONLY` or if this method is called when the cursor is on the insert row
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method or this method is not supported for the specified result set type and result set concurrency.
Since:
  1.2

#### cancelRowUpdates

    public void cancelRowUpdates()
                          throws SQLException

Cancels the updates made to the current row in this `ResultSet` object. This method may be called after calling an updater method(s) and before calling the method `updateRow` to roll back the updates made to a row. If no updates have been made or `updateRow` has already been called, this method has no effect.

Specified by:
  `cancelRowUpdates` in interface `ResultSet`
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set; the result set concurrency is `CONCUR_READ_ONLY` or if this method is called when the cursor is on the insert row
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### moveToInsertRow

    public void moveToInsertRow()
                         throws SQLException

Moves the cursor to the insert row. The current cursor position is remembered while the cursor is positioned on the insert row.

The insert row is a special row associated with an updatable result set. It is essentially a buffer where a new row may be constructed by calling the updater methods prior to inserting the row into the result set.

Only the updater, getter, and `insertRow` methods may be called when the cursor is on the insert row. All of the columns in a result set must be given a value each time this method is called before calling `insertRow`. An updater method must be called before a getter method can be called on a column value.

Specified by:
  `moveToInsertRow` in interface `ResultSet`
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the result set concurrency is `CONCUR_READ_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### moveToCurrentRow

    public void moveToCurrentRow()
                          throws SQLException

Moves the cursor to the remembered cursor position, usually the current row. This method has no effect if the cursor is not on the insert row.

Specified by:
  `moveToCurrentRow` in interface `ResultSet`
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed result set or the result set concurrency is `CONCUR_READ_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getStatement

    public Statement getStatement()
                           throws SQLException

Retrieves the `Statement` object that produced this `ResultSet` object. If the result set was generated some other way, such as by a `DatabaseMetaData` method, this method may return `null`.

Specified by:
  `getStatement` in interface `ResultSet`
Returns:
  the `Statment` object that produced this `ResultSet` object or `null` if the result set was produced some other way
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getObject

    public Object getObject(int columnIndex,
                   Map<String,Class<?>> map)
                     throws SQLException

According to the JDBC4 spec, this is only required for UDT's, and since drizzle does not support UDTs, this method ignores the map parameter

Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language. If the value is an SQL `NULL`, the driver returns a Java `null`. This method uses the given `Map` object for the custom mapping of the SQL structured or distinct type that is being retrieved.

Specified by:
  `getObject` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `map` - a `java.util.Map` object that contains the mapping from SQL type names to classes in the Java programming language
Returns:
  an `Object` in the Java programming language representing the SQL value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getRef

    public Ref getRef(int columnIndex)
               throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Ref` object in the Java programming language.

Specified by:
  `getRef` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a `Ref` object representing an SQL `REF` value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getBlob

    public Blob getBlob(int columnIndex)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Blob` object in the Java programming language.

Specified by:
  `getBlob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a `Blob` object representing the SQL `BLOB` value in the specified column
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getClob

    public Clob getClob(int columnIndex)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Clob` object in the Java programming language.

Specified by:
  `getClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a `Clob` object representing the SQL `CLOB` value in the specified column
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getArray

    public Array getArray(int columnIndex)
                   throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Array` object in the Java programming language.

Specified by:
  `getArray` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  an `Array` object representing the SQL `ARRAY` value in the specified column
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getObject

    public Object getObject(String columnLabel,
                   Map<String,Class<?>> map)
                     throws SQLException

According to the JDBC4 spec, this is only required for UDT's, and since drizzle does not support UDTs, this method ignores the map parameter

Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Object` in the Java programming language. If the value is an SQL `NULL`, the driver returns a Java `null`. This method uses the specified `Map` object for custom mapping if appropriate.

Specified by:
  `getObject` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `map` - a `java.util.Map` object that contains the mapping from SQL type names to classes in the Java programming language
Returns:
  an `Object` representing the SQL value in the specified column
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getRef

    public Ref getRef(String columnLabel)
               throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Ref` object in the Java programming language.

Specified by:
  `getRef` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a `Ref` object representing the SQL `REF` value in the specified column
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getBlob

    public Blob getBlob(String columnLabel)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Blob` object in the Java programming language.

Specified by:
  `getBlob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a `Blob` object representing the SQL `BLOB` value in the specified column
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getClob

    public Clob getClob(String columnLabel)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `Clob` object in the Java programming language.

Specified by:
  `getClob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a `Clob` object representing the SQL `CLOB` value in the specified column
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getArray

    public Array getArray(String columnLabel)
                   throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as an `Array` object in the Java programming language.

Specified by:
  `getArray` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  an `Array` object representing the SQL `ARRAY` value in the specified column
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### getDate

    public Date getDate(int columnIndex,
               Calendar cal)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the date if the underlying database does not store timezone information.

Specified by:
  `getDate` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `cal` - the `java.util.Calendar` object to use in constructing the date
Returns:
  the column value as a `java.sql.Date` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getDate

    public Date getDate(String columnLabel,
               Calendar cal)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the date if the underlying database does not store timezone information.

Specified by:
  `getDate` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `cal` - the `java.util.Calendar` object to use in constructing the date
Returns:
  the column value as a `java.sql.Date` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getTime

    public Time getTime(int columnIndex,
               Calendar cal)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the time if the underlying database does not store timezone information.

Specified by:
  `getTime` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `cal` - the `java.util.Calendar` object to use in constructing the time
Returns:
  the column value as a `java.sql.Time` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getTime

    public Time getTime(String columnLabel,
               Calendar cal)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the time if the underlying database does not store timezone information.

Specified by:
  `getTime` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `cal` - the `java.util.Calendar` object to use in constructing the time
Returns:
  the column value as a `java.sql.Time` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getTimestamp

    public Timestamp getTimestamp(int columnIndex,
                         Calendar cal)
                           throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the timestamp if the underlying database does not store timezone information.

Specified by:
  `getTimestamp` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `cal` - the `java.util.Calendar` object to use in constructing the timestamp
Returns:
  the column value as a `java.sql.Timestamp` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getTimestamp

    public Timestamp getTimestamp(String columnLabel,
                         Calendar cal)
                           throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language. This method uses the given calendar to construct an appropriate millisecond value for the timestamp if the underlying database does not store timezone information.

Specified by:
  `getTimestamp` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `cal` - the `java.util.Calendar` object to use in constructing the date
Returns:
  the column value as a `java.sql.Timestamp` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
Throws:
  `SQLException` - if the columnLabel is not valid or if a database access error occurs or this method is called on a closed result set
Since:
  1.2

#### getURL

    public URL getURL(int columnIndex)
               throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.net.URL` object in the Java programming language.

Specified by:
  `getURL` in interface `ResultSet`
Parameters:
  `columnIndex` - the index of the column 1 is the first, 2 is the second,...
Returns:
  the column value as a `java.net.URL` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; this method is called on a closed result set or if a URL is malformed
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### getURL

    public URL getURL(String columnLabel)
               throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.net.URL` object in the Java programming language.

Specified by:
  `getURL` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value as a `java.net.URL` object; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; this method is called on a closed result set or if a URL is malformed
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### updateRef

    public void updateRef(int columnIndex,
                 Ref x)
                   throws SQLException

Updates the designated column with a `java.sql.Ref` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateRef` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### updateRef

    public void updateRef(String columnLabel,
                 Ref x)
                   throws SQLException

Updates the designated column with a `java.sql.Ref` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateRef` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### updateBlob

    public void updateBlob(int columnIndex,
                  Blob x)
                    throws SQLException

Updates the designated column with a `java.sql.Blob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### updateBlob

    public void updateBlob(String columnLabel,
                  Blob x)
                    throws SQLException

Updates the designated column with a `java.sql.Blob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### updateClob

    public void updateClob(int columnIndex,
                  Clob x)
                    throws SQLException

Updates the designated column with a `java.sql.Clob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### updateClob

    public void updateClob(String columnLabel,
                  Clob x)
                    throws SQLException

Updates the designated column with a `java.sql.Clob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### updateArray

    public void updateArray(int columnIndex,
                   Array x)
                     throws SQLException

Updates the designated column with a `java.sql.Array` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateArray` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### updateArray

    public void updateArray(String columnLabel,
                   Array x)
                     throws SQLException

Updates the designated column with a `java.sql.Array` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateArray` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

#### getRowId

    public RowId getRowId(int columnIndex)
                   throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.RowId` object in the Java programming language.

Specified by:
  `getRowId` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second 2, ...
Returns:
  the column value; if the value is a SQL `NULL` the value returned is `null`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getRowId

    public RowId getRowId(String columnLabel)
                   throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.RowId` object in the Java programming language.

Specified by:
  `getRowId` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value ; if the value is a SQL `NULL` the value returned is `null`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateRowId

    public void updateRowId(int columnIndex,
                   RowId x)
                     throws SQLException

Updates the designated column with a `RowId` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateRowId` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second 2, ...
  `x` - the column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateRowId

    public void updateRowId(String columnLabel,
                   RowId x)
                     throws SQLException

Updates the designated column with a `RowId` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateRowId` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getHoldability

    public int getHoldability()
                       throws SQLException

Retrieves the holdability of this `ResultSet` object

Specified by:
  `getHoldability` in interface `ResultSet`
Returns:
  either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed result set
Since:
  1.6

#### isClosed

    public boolean isClosed()
                     throws SQLException

Retrieves whether this `ResultSet` object has been closed. A `ResultSet` is closed if the method close has been called on it, or if it is automatically closed.

Specified by:
  `isClosed` in interface `ResultSet`
Returns:
  true if this `ResultSet` object is closed; false if it is still open
Throws:
  `SQLException` - if a database access error occurs
Since:
  1.6

#### updateNString

    public void updateNString(int columnIndex,
                     String nString)
                       throws SQLException

Updates the designated column with a `String` value. It is intended for use when updating `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateNString` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second 2, ...
  `nString` - the value for the column to be updated
Throws:
  `SQLException` - if the columnIndex is not valid; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; this method is called on a closed result set; the result set concurrency is `CONCUR_READ_ONLY` or if a database access error occurs
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNString

    public void updateNString(String columnLabel,
                     String nString)
                       throws SQLException

Updates the designated column with a `String` value. It is intended for use when updating `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateNString` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `nString` - the value for the column to be updated
Throws:
  `SQLException` - if the columnLabel is not valid; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; this method is called on a closed result set; the result set concurrency is `CONCUR_READ_ONLY` or if a database access error occurs
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNClob

    public void updateNClob(int columnIndex,
                   NClob nClob)
                     throws SQLException

Updates the designated column with a `java.sql.NClob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateNClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second 2, ...
  `nClob` - the value for the column to be updated
Throws:
  `SQLException` - if the columnIndex is not valid; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; this method is called on a closed result set; if a database access error occurs or the result set concurrency is `CONCUR_READ_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNClob

    public void updateNClob(String columnLabel,
                   NClob nClob)
                     throws SQLException

Updates the designated column with a `java.sql.NClob` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateNClob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `nClob` - the value for the column to be updated
Throws:
  `SQLException` - if the columnLabel is not valid; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; this method is called on a closed result set; if a database access error occurs or the result set concurrency is `CONCUR_READ_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getNClob

    public NClob getNClob(int columnIndex)
                   throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `NClob` object in the Java programming language.

Specified by:
  `getNClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a `NClob` object representing the SQL `NCLOB` value in the specified column
Throws:
  `SQLException` - if the columnIndex is not valid; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; this method is called on a closed result set or if a database access error occurs
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getNClob

    public NClob getNClob(String columnLabel)
                   throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `NClob` object in the Java programming language.

Specified by:
  `getNClob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a `NClob` object representing the SQL `NCLOB` value in the specified column
Throws:
  `SQLException` - if the columnLabel is not valid; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; this method is called on a closed result set or if a database access error occurs
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getSQLXML

    public SQLXML getSQLXML(int columnIndex)
                     throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` as a `java.sql.SQLXML` object in the Java programming language.

Specified by:
  `getSQLXML` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a `SQLXML` object that maps an `SQL XML` value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getSQLXML

    public SQLXML getSQLXML(String columnLabel)
                     throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` as a `java.sql.SQLXML` object in the Java programming language.

Specified by:
  `getSQLXML` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a `SQLXML` object that maps an `SQL XML` value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateSQLXML

    public void updateSQLXML(int columnIndex,
                    SQLXML xmlObject)
                      throws SQLException

Updates the designated column with a `java.sql.SQLXML` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateSQLXML` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second 2, ...
  `xmlObject` - the value for the column to be updated
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; this method is called on a closed result set; the `java.xml.transform.Result`, `Writer` or `OutputStream` has not been closed for the `SQLXML` object; if there is an error processing the XML value or the result set concurrency is `CONCUR_READ_ONLY`. The `getCause` method of the exception may provide a more detailed exception, for example, if the stream does not contain valid XML.
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateSQLXML

    public void updateSQLXML(String columnLabel,
                    SQLXML xmlObject)
                      throws SQLException

Updates the designated column with a `java.sql.SQLXML` value. The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateSQLXML` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `xmlObject` - the column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; this method is called on a closed result set; the `java.xml.transform.Result`, `Writer` or `OutputStream` has not been closed for the `SQLXML` object; if there is an error processing the XML value or the result set concurrency is `CONCUR_READ_ONLY`. The `getCause` method of the exception may provide a more detailed exception, for example, if the stream does not contain valid XML.
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getNString

    public String getNString(int columnIndex)
                      throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `String` in the Java programming language. It is intended for use when accessing `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns.

Specified by:
  `getNString` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getNString

    public String getNString(String columnLabel)
                      throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `String` in the Java programming language. It is intended for use when accessing `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns.

Specified by:
  `getNString` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getNCharacterStream

    public Reader getNCharacterStream(int columnIndex)
                               throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object. It is intended for use when accessing `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns.

Specified by:
  `getNCharacterStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a `java.io.Reader` object that contains the column value; if the value is SQL `NULL`, the value returned is `null` in the Java programming language.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getNCharacterStream

    public Reader getNCharacterStream(String columnLabel)
                               throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.io.Reader` object. It is intended for use when accessing `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns.

Specified by:
  `getNCharacterStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  a `java.io.Reader` object that contains the column value; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNCharacterStream

    public void updateNCharacterStream(int columnIndex,
                              Reader x,
                              long length)
                                throws SQLException

Updates the designated column with a character stream value, which will have the specified number of bytes. The driver does the necessary conversion from Java character format to the national character set in the database. It is intended for use when updating `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNCharacterStream

    public void updateNCharacterStream(String columnLabel,
                              Reader reader,
                              long length)
                                throws SQLException

Updates the designated column with a character stream value, which will have the specified number of bytes. The driver does the necessary conversion from Java character format to the national character set in the database. It is intended for use when updating `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - the `java.io.Reader` object containing the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateAsciiStream

    public void updateAsciiStream(int columnIndex,
                         InputStream x,
                         long length)
                           throws SQLException

Updates the designated column with an ascii stream value, which will have the specified number of bytes.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateBinaryStream

    public void updateBinaryStream(int columnIndex,
                          InputStream x,
                          long length)
                            throws SQLException

Updates the designated column with a binary stream value, which will have the specified number of bytes.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateCharacterStream

    public void updateCharacterStream(int columnIndex,
                             Reader x,
                             long length)
                               throws SQLException

Updates the designated column with a character stream value, which will have the specified number of bytes.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateAsciiStream

    public void updateAsciiStream(String columnLabel,
                         InputStream x,
                         long length)
                           throws SQLException

Updates the designated column with an ascii stream value, which will have the specified number of bytes.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateBinaryStream

    public void updateBinaryStream(String columnLabel,
                          InputStream x,
                          long length)
                            throws SQLException

Updates the designated column with a binary stream value, which will have the specified number of bytes.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateCharacterStream

    public void updateCharacterStream(String columnLabel,
                             Reader reader,
                             long length)
                               throws SQLException

Updates the designated column with a character stream value, which will have the specified number of bytes.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - the `java.io.Reader` object containing the new column value
  `length` - the length of the stream
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateBlob

    public void updateBlob(int columnIndex,
                  InputStream inputStream,
                  long length)
                    throws SQLException

Updates the designated column using the given input stream, which will have the specified number of bytes.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `inputStream` - An object that contains the data to set the parameter value to.
  `length` - the number of bytes in the parameter data.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateBlob

    public void updateBlob(String columnLabel,
                  InputStream inputStream,
                  long length)
                    throws SQLException

Updates the designated column using the given input stream, which will have the specified number of bytes.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `inputStream` - An object that contains the data to set the parameter value to.
  `length` - the number of bytes in the parameter data.
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateClob

    public void updateClob(int columnIndex,
                  Reader reader,
                  long length)
                    throws SQLException

Updates the designated column using the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateClob

    public void updateClob(String columnLabel,
                  Reader reader,
                  long length)
                    throws SQLException

Updates the designated column using the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNClob

    public void updateNClob(int columnIndex,
                   Reader reader,
                   long length)
                     throws SQLException

Updates the designated column using the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateNClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second 2, ...
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if the columnIndex is not valid; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; this method is called on a closed result set, if a database access error occurs or the result set concurrency is `CONCUR_READ_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNClob

    public void updateNClob(String columnLabel,
                   Reader reader,
                   long length)
                     throws SQLException

Updates the designated column using the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Specified by:
  `updateNClob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if the columnLabel is not valid; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; this method is called on a closed result set; if a database access error occurs or the result set concurrency is `CONCUR_READ_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNCharacterStream

    public void updateNCharacterStream(int columnIndex,
                              Reader x)
                                throws SQLException

Updates the designated column with a character stream value. The data will be read from the stream as needed until end-of-stream is reached. The driver does the necessary conversion from Java character format to the national character set in the database. It is intended for use when updating `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateNCharacterStream` which takes a length parameter.

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNCharacterStream

    public void updateNCharacterStream(String columnLabel,
                              Reader reader)
                                throws SQLException

Updates the designated column with a character stream value. The data will be read from the stream as needed until end-of-stream is reached. The driver does the necessary conversion from Java character format to the national character set in the database. It is intended for use when updating `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` columns.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateNCharacterStream` which takes a length parameter.

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - the `java.io.Reader` object containing the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateAsciiStream

    public void updateAsciiStream(int columnIndex,
                         InputStream x)
                           throws SQLException

Updates the designated column with an ascii stream value. The data will be read from the stream as needed until end-of-stream is reached.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateAsciiStream` which takes a length parameter.

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateBinaryStream

    public void updateBinaryStream(int columnIndex,
                          InputStream x)
                            throws SQLException

Updates the designated column with a binary stream value. The data will be read from the stream as needed until end-of-stream is reached.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateBinaryStream` which takes a length parameter.

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateCharacterStream

    public void updateCharacterStream(int columnIndex,
                             Reader x)
                               throws SQLException

Updates the designated column with a character stream value. The data will be read from the stream as needed until end-of-stream is reached.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateCharacterStream` which takes a length parameter.

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `x` - the new column value
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateAsciiStream

    public void updateAsciiStream(String columnLabel,
                         InputStream x)
                           throws SQLException

Updates the designated column with an ascii stream value. The data will be read from the stream as needed until end-of-stream is reached.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateAsciiStream` which takes a length parameter.

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateBinaryStream

    public void updateBinaryStream(String columnLabel,
                          InputStream x)
                            throws SQLException

Updates the designated column with a binary stream value. The data will be read from the stream as needed until end-of-stream is reached.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateBinaryStream` which takes a length parameter.

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `x` - the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateCharacterStream

    public void updateCharacterStream(String columnLabel,
                             Reader reader)
                               throws SQLException

Updates the designated column with a character stream value. The data will be read from the stream as needed until end-of-stream is reached.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateCharacterStream` which takes a length parameter.

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - the `java.io.Reader` object containing the new column value
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateBlob

    public void updateBlob(int columnIndex,
                  InputStream inputStream)
                    throws SQLException

Updates the designated column using the given input stream. The data will be read from the stream as needed until end-of-stream is reached.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateBlob` which takes a length parameter.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `inputStream` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateBlob

    public void updateBlob(String columnLabel,
                  InputStream inputStream)
                    throws SQLException

Updates the designated column using the given input stream. The data will be read from the stream as needed until end-of-stream is reached.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateBlob` which takes a length parameter.

Specified by:
  `updateBlob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `inputStream` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateClob

    public void updateClob(int columnIndex,
                  Reader reader)
                    throws SQLException

Updates the designated column using the given `Reader` object. The data will be read from the stream as needed until end-of-stream is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateClob` which takes a length parameter.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateClob

    public void updateClob(String columnLabel,
                  Reader reader)
                    throws SQLException

Updates the designated column using the given `Reader` object. The data will be read from the stream as needed until end-of-stream is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateClob` which takes a length parameter.

Specified by:
  `updateClob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs; the result set concurrency is `CONCUR_READ_ONLY` or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNClob

    public void updateNClob(int columnIndex,
                   Reader reader)
                     throws SQLException

Updates the designated column using the given `Reader`

The data will be read from the stream as needed until end-of-stream is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateNClob` which takes a length parameter.

Specified by:
  `updateNClob` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second 2, ...
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if the columnIndex is not valid; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; this method is called on a closed result set, if a database access error occurs or the result set concurrency is `CONCUR_READ_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### updateNClob

    public void updateNClob(String columnLabel,
                   Reader reader)
                     throws SQLException

Updates the designated column using the given `Reader` object. The data will be read from the stream as needed until end-of-stream is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

The updater methods are used to update column values in the current row or the insert row. The updater methods do not update the underlying database; instead the `updateRow` or `insertRow` methods are called to update the database.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `updateNClob` which takes a length parameter.

Specified by:
  `updateNClob` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if the columnLabel is not valid; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; this method is called on a closed result set; if a database access error occurs or the result set concurrency is `CONCUR_READ_ONLY`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

#### getBoolean

    public boolean getBoolean(int i)
                       throws SQLException

Specified by:
  `getBoolean` in interface `ResultSet`
Throws:
  `SQLException`

#### getByte

    public byte getByte(int i)
                 throws SQLException

Specified by:
  `getByte` in interface `ResultSet`
Throws:
  `SQLException`

#### getShort

    public short getShort(int i)
                   throws SQLException

Specified by:
  `getShort` in interface `ResultSet`
Throws:
  `SQLException`

#### getLong

    public long getLong(int i)
                 throws SQLException

Specified by:
  `getLong` in interface `ResultSet`
Throws:
  `SQLException`

#### getFloat

    public float getFloat(int i)
                   throws SQLException

Specified by:
  `getFloat` in interface `ResultSet`
Throws:
  `SQLException`

#### getDouble

    public double getDouble(int i)
                     throws SQLException

Specified by:
  `getDouble` in interface `ResultSet`
Throws:
  `SQLException`

#### getBigDecimal

    public BigDecimal getBigDecimal(int columnIndex,
                           int scale)
                             throws SQLException

Deprecated.
Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.BigDecimal` in the Java programming language.

Specified by:
  `getBigDecimal` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
  `scale` - the number of digits to the right of the decimal point
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### getBytes

    public byte[] getBytes(int columnIndex)
                    throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` array in the Java programming language. The bytes represent the raw values returned by the driver.

Specified by:
  `getBytes` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set

#### getDate

    public Date getDate(int columnIndex)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Date` object in the Java programming language.

Specified by:
  `getDate` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set

#### getTime

    public Time getTime(int columnIndex)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Time` object in the Java programming language.

Specified by:
  `getTime` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set

#### getTimestamp

    public Timestamp getTimestamp(int columnIndex)
                           throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `java.sql.Timestamp` object in the Java programming language.

Specified by:
  `getTimestamp` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set

#### getAsciiStream

    public InputStream getAsciiStream(int columnIndex)
                               throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of ASCII characters. The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large <char>LONGVARCHAR</char> values. The JDBC driver will do any necessary conversion from the database format into ASCII.

Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `InputStream.available` is called whether there is data available or not.

Specified by:
  `getAsciiStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a Java input stream that delivers the database column value as a stream of one-byte ASCII characters; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set

#### getUnicodeStream

    public InputStream getUnicodeStream(int columnIndex)
                                 throws SQLException

Deprecated. use `getCharacterStream` in place of `getUnicodeStream`
Retrieves the value of the designated column in the current row of this `ResultSet` object as as a stream of two-byte 3 characters. The first byte is the high byte; the second byte is the low byte.

The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large `LONGVARCHAR`values. The JDBC driver will do any necessary conversion from the database format into Unicode.

Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `InputStream.available` is called, whether there is data available or not.

Specified by:
  `getUnicodeStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a Java input stream that delivers the database column value as a stream of two-byte Unicode characters; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

#### getBinaryStream

    public InputStream getBinaryStream(int columnIndex)
                                throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a stream of uninterpreted bytes. The value can then be read in chunks from the stream. This method is particularly suitable for retrieving large `LONGVARBINARY` values.

Note: All the data in the returned stream must be read prior to getting the value of any other column. The next call to a getter method implicitly closes the stream. Also, a stream may return `0` when the method `InputStream.available` is called whether there is data available or not.

Specified by:
  `getBinaryStream` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  a Java input stream that delivers the database column value as a stream of uninterpreted bytes; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs or this method is called on a closed result set

#### getString

    public String getString(String columnLabel)
                     throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `String` in the Java programming language.

Specified by:
  `getString` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `null`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getBoolean

    public boolean getBoolean(String columnLabel)
                       throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `boolean` in the Java programming language.

If the designated column has a datatype of CHAR or VARCHAR and contains a "0" or has a datatype of BIT, TINYINT, SMALLINT, INTEGER or BIGINT and contains a 0, a value of `false` is returned. If the designated column has a datatype of CHAR or VARCHAR and contains a "1" or has a datatype of BIT, TINYINT, SMALLINT, INTEGER or BIGINT and contains a 1, a value of `true` is returned.

Specified by:
  `getBoolean` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `false`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getByte

    public byte getByte(String columnLabel)
                 throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `byte` in the Java programming language.

Specified by:
  `getByte` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `0`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### getShort

    public short getShort(String columnLabel)
                   throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `short` in the Java programming language.

Specified by:
  `getShort` in interface `ResultSet`
Parameters:
  `columnLabel` - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `0`
Throws:
  `SQLException` - if the columnLabel is not valid; if a database access error occurs or this method is called on a closed result set

#### unwrap

    public <T> T unwrap(Class<T> iface)
             throws SQLException

Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

Specified by:
  `unwrap` in interface `Wrapper`
Parameters:
  `iface` - A Class defining an interface that the result must implement.
Returns:
  an object that implements the interface. May be a proxy for the actual implementing object.
Throws:
  `SQLException` - If no object found that implements the interface
Since:
  1.6

#### isWrapperFor

    public boolean isWrapperFor(Class<?> iface)
                         throws SQLException

Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

Specified by:
  `isWrapperFor` in interface `Wrapper`
Parameters:
  `iface` - a Class defining an interface.
Returns:
  true if this implements the interface or directly or indirectly wraps an object that does.
Throws:
  `SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.
Since:
  1.6

#### getObject

    public <T> T getObject(int arg0,
                  Class<T> arg1)
                throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public <T> T getObject(String arg0,
                  Class<T> arg1)
                throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`